Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/diffequations.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/diffequations.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/diffequations.cs	(revision 7294)
@@ -168,19 +168,4 @@
         obj     -   optional object which is passed to diff; can be NULL
 
-    One iteration of ODE solver.
-
-    Called after inialization of State structure with OdeSolverXXX subroutine.
-    See HTML docs for examples.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state between subsequent
-                    calls and which is used for reverse communication. Must be
-                    initialized with OdeSolverXXX() call first.
-
-    If subroutine returned False, algorithm have finished its work.
-    If subroutine returned True, then user should:
-    * calculate F(State.X, State.Y)
-    * store it in State.DY
-    Here State.X is real, State.Y and State.DY are arrays[0..N-1] of reals.
 
       -- ALGLIB --
@@ -372,19 +357,4 @@
 
         /*************************************************************************
-        One iteration of ODE solver.
-
-        Called after inialization of State structure with OdeSolverXXX subroutine.
-        See HTML docs for examples.
-
-        INPUT PARAMETERS:
-            State   -   structure which stores algorithm state between subsequent
-                        calls and which is used for reverse communication. Must be
-                        initialized with OdeSolverXXX() call first.
-
-        If subroutine returned False, algorithm have finished its work.
-        If subroutine returned True, then user should:
-        * calculate F(State.X, State.Y)
-        * store it in State.DY
-        Here State.X is real, State.Y and State.DY are arrays[0..N-1] of reals.
 
           -- ALGLIB --
@@ -472,6 +442,4 @@
             m = state.m;
             h = state.h;
-            state.y = new double[n];
-            state.dy = new double[n];
             maxgrowpow = Math.Pow(odesolvermaxgrow, 5);
             state.repnfev = 0;
@@ -965,4 +933,10 @@
             state.solvertype = solvertype;
             state.repterminationtype = 0;
+            
+            //
+            // Allocate arrays
+            //
+            state.y = new double[n];
+            state.dy = new double[n];
         }
 
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/fasttransforms.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/fasttransforms.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/fasttransforms.cs	(revision 7294)
@@ -21,270 +21,4 @@
 using System;
 
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    1-dimensional complex convolution.
-
-    For given A/B returns conv(A,B) (non-circular). Subroutine can automatically
-    choose between three implementations: straightforward O(M*N)  formula  for
-    very small N (or M), overlap-add algorithm for  cases  where  max(M,N)  is
-    significantly larger than min(M,N), but O(M*N) algorithm is too slow,  and
-    general FFT-based formula for cases where two previois algorithms are  too
-    slow.
-
-    Algorithm has max(M,N)*log(max(M,N)) complexity for any M/N.
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - complex function to be transformed
-        M   -   problem size
-        B   -   array[0..N-1] - complex function to be transformed
-        N   -   problem size
-
-    OUTPUT PARAMETERS
-        R   -   convolution: A*B. array[0..N+M-2].
-
-    NOTE:
-        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
-    functions have non-zero values at negative T's, you  can  still  use  this
-    subroutine - just shift its result correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convc1d(complex[] a, int m, complex[] b, int n, out complex[] r)
-    {
-        r = new complex[0];
-        conv.convc1d(a, m, b, n, ref r);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional complex non-circular deconvolution (inverse of ConvC1D()).
-
-    Algorithm has M*log(M)) complexity for any M (composite or prime).
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
-        M   -   convolved signal length
-        B   -   array[0..N-1] - response
-        N   -   response length, N<=M
-
-    OUTPUT PARAMETERS
-        R   -   deconvolved signal. array[0..M-N].
-
-    NOTE:
-        deconvolution is unstable process and may result in division  by  zero
-    (if your response function is degenerate, i.e. has zero Fourier coefficient).
-
-    NOTE:
-        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
-    functions have non-zero values at negative T's, you  can  still  use  this
-    subroutine - just shift its result correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convc1dinv(complex[] a, int m, complex[] b, int n, out complex[] r)
-    {
-        r = new complex[0];
-        conv.convc1dinv(a, m, b, n, ref r);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional circular complex convolution.
-
-    For given S/R returns conv(S,R) (circular). Algorithm has linearithmic
-    complexity for any M/N.
-
-    IMPORTANT:  normal convolution is commutative,  i.e.   it  is symmetric  -
-    conv(A,B)=conv(B,A).  Cyclic convolution IS NOT.  One function - S - is  a
-    signal,  periodic function, and another - R - is a response,  non-periodic
-    function with limited length.
-
-    INPUT PARAMETERS
-        S   -   array[0..M-1] - complex periodic signal
-        M   -   problem size
-        B   -   array[0..N-1] - complex non-periodic response
-        N   -   problem size
-
-    OUTPUT PARAMETERS
-        R   -   convolution: A*B. array[0..M-1].
-
-    NOTE:
-        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
-    negative T's, you can still use this subroutine - just  shift  its  result
-    correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convc1dcircular(complex[] s, int m, complex[] r, int n, out complex[] c)
-    {
-        c = new complex[0];
-        conv.convc1dcircular(s, m, r, n, ref c);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional circular complex deconvolution (inverse of ConvC1DCircular()).
-
-    Algorithm has M*log(M)) complexity for any M (composite or prime).
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - convolved periodic signal, A = conv(R, B)
-        M   -   convolved signal length
-        B   -   array[0..N-1] - non-periodic response
-        N   -   response length
-
-    OUTPUT PARAMETERS
-        R   -   deconvolved signal. array[0..M-1].
-
-    NOTE:
-        deconvolution is unstable process and may result in division  by  zero
-    (if your response function is degenerate, i.e. has zero Fourier coefficient).
-
-    NOTE:
-        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
-    negative T's, you can still use this subroutine - just  shift  its  result
-    correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convc1dcircularinv(complex[] a, int m, complex[] b, int n, out complex[] r)
-    {
-        r = new complex[0];
-        conv.convc1dcircularinv(a, m, b, n, ref r);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional real convolution.
-
-    Analogous to ConvC1D(), see ConvC1D() comments for more details.
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - real function to be transformed
-        M   -   problem size
-        B   -   array[0..N-1] - real function to be transformed
-        N   -   problem size
-
-    OUTPUT PARAMETERS
-        R   -   convolution: A*B. array[0..N+M-2].
-
-    NOTE:
-        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
-    functions have non-zero values at negative T's, you  can  still  use  this
-    subroutine - just shift its result correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convr1d(double[] a, int m, double[] b, int n, out double[] r)
-    {
-        r = new double[0];
-        conv.convr1d(a, m, b, n, ref r);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional real deconvolution (inverse of ConvC1D()).
-
-    Algorithm has M*log(M)) complexity for any M (composite or prime).
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
-        M   -   convolved signal length
-        B   -   array[0..N-1] - response
-        N   -   response length, N<=M
-
-    OUTPUT PARAMETERS
-        R   -   deconvolved signal. array[0..M-N].
-
-    NOTE:
-        deconvolution is unstable process and may result in division  by  zero
-    (if your response function is degenerate, i.e. has zero Fourier coefficient).
-
-    NOTE:
-        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
-    functions have non-zero values at negative T's, you  can  still  use  this
-    subroutine - just shift its result correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convr1dinv(double[] a, int m, double[] b, int n, out double[] r)
-    {
-        r = new double[0];
-        conv.convr1dinv(a, m, b, n, ref r);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional circular real convolution.
-
-    Analogous to ConvC1DCircular(), see ConvC1DCircular() comments for more details.
-
-    INPUT PARAMETERS
-        S   -   array[0..M-1] - real signal
-        M   -   problem size
-        B   -   array[0..N-1] - real response
-        N   -   problem size
-
-    OUTPUT PARAMETERS
-        R   -   convolution: A*B. array[0..M-1].
-
-    NOTE:
-        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
-    negative T's, you can still use this subroutine - just  shift  its  result
-    correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convr1dcircular(double[] s, int m, double[] r, int n, out double[] c)
-    {
-        c = new double[0];
-        conv.convr1dcircular(s, m, r, n, ref c);
-        return;
-    }
-
-    /*************************************************************************
-    1-dimensional complex deconvolution (inverse of ConvC1D()).
-
-    Algorithm has M*log(M)) complexity for any M (composite or prime).
-
-    INPUT PARAMETERS
-        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
-        M   -   convolved signal length
-        B   -   array[0..N-1] - response
-        N   -   response length
-
-    OUTPUT PARAMETERS
-        R   -   deconvolved signal. array[0..M-N].
-
-    NOTE:
-        deconvolution is unstable process and may result in division  by  zero
-    (if your response function is degenerate, i.e. has zero Fourier coefficient).
-
-    NOTE:
-        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
-    negative T's, you can still use this subroutine - just  shift  its  result
-    correspondingly.
-
-      -- ALGLIB --
-         Copyright 21.07.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void convr1dcircularinv(double[] a, int m, double[] b, int n, out double[] r)
-    {
-        r = new double[0];
-        conv.convr1dcircularinv(a, m, b, n, ref r);
-        return;
-    }
-
-}
 public partial class alglib
 {
@@ -472,4 +206,270 @@
 
     /*************************************************************************
+    1-dimensional complex convolution.
+
+    For given A/B returns conv(A,B) (non-circular). Subroutine can automatically
+    choose between three implementations: straightforward O(M*N)  formula  for
+    very small N (or M), overlap-add algorithm for  cases  where  max(M,N)  is
+    significantly larger than min(M,N), but O(M*N) algorithm is too slow,  and
+    general FFT-based formula for cases where two previois algorithms are  too
+    slow.
+
+    Algorithm has max(M,N)*log(max(M,N)) complexity for any M/N.
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - complex function to be transformed
+        M   -   problem size
+        B   -   array[0..N-1] - complex function to be transformed
+        N   -   problem size
+
+    OUTPUT PARAMETERS
+        R   -   convolution: A*B. array[0..N+M-2].
+
+    NOTE:
+        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
+    functions have non-zero values at negative T's, you  can  still  use  this
+    subroutine - just shift its result correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convc1d(complex[] a, int m, complex[] b, int n, out complex[] r)
+    {
+        r = new complex[0];
+        conv.convc1d(a, m, b, n, ref r);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional complex non-circular deconvolution (inverse of ConvC1D()).
+
+    Algorithm has M*log(M)) complexity for any M (composite or prime).
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
+        M   -   convolved signal length
+        B   -   array[0..N-1] - response
+        N   -   response length, N<=M
+
+    OUTPUT PARAMETERS
+        R   -   deconvolved signal. array[0..M-N].
+
+    NOTE:
+        deconvolution is unstable process and may result in division  by  zero
+    (if your response function is degenerate, i.e. has zero Fourier coefficient).
+
+    NOTE:
+        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
+    functions have non-zero values at negative T's, you  can  still  use  this
+    subroutine - just shift its result correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convc1dinv(complex[] a, int m, complex[] b, int n, out complex[] r)
+    {
+        r = new complex[0];
+        conv.convc1dinv(a, m, b, n, ref r);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional circular complex convolution.
+
+    For given S/R returns conv(S,R) (circular). Algorithm has linearithmic
+    complexity for any M/N.
+
+    IMPORTANT:  normal convolution is commutative,  i.e.   it  is symmetric  -
+    conv(A,B)=conv(B,A).  Cyclic convolution IS NOT.  One function - S - is  a
+    signal,  periodic function, and another - R - is a response,  non-periodic
+    function with limited length.
+
+    INPUT PARAMETERS
+        S   -   array[0..M-1] - complex periodic signal
+        M   -   problem size
+        B   -   array[0..N-1] - complex non-periodic response
+        N   -   problem size
+
+    OUTPUT PARAMETERS
+        R   -   convolution: A*B. array[0..M-1].
+
+    NOTE:
+        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
+    negative T's, you can still use this subroutine - just  shift  its  result
+    correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convc1dcircular(complex[] s, int m, complex[] r, int n, out complex[] c)
+    {
+        c = new complex[0];
+        conv.convc1dcircular(s, m, r, n, ref c);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional circular complex deconvolution (inverse of ConvC1DCircular()).
+
+    Algorithm has M*log(M)) complexity for any M (composite or prime).
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - convolved periodic signal, A = conv(R, B)
+        M   -   convolved signal length
+        B   -   array[0..N-1] - non-periodic response
+        N   -   response length
+
+    OUTPUT PARAMETERS
+        R   -   deconvolved signal. array[0..M-1].
+
+    NOTE:
+        deconvolution is unstable process and may result in division  by  zero
+    (if your response function is degenerate, i.e. has zero Fourier coefficient).
+
+    NOTE:
+        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
+    negative T's, you can still use this subroutine - just  shift  its  result
+    correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convc1dcircularinv(complex[] a, int m, complex[] b, int n, out complex[] r)
+    {
+        r = new complex[0];
+        conv.convc1dcircularinv(a, m, b, n, ref r);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional real convolution.
+
+    Analogous to ConvC1D(), see ConvC1D() comments for more details.
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - real function to be transformed
+        M   -   problem size
+        B   -   array[0..N-1] - real function to be transformed
+        N   -   problem size
+
+    OUTPUT PARAMETERS
+        R   -   convolution: A*B. array[0..N+M-2].
+
+    NOTE:
+        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
+    functions have non-zero values at negative T's, you  can  still  use  this
+    subroutine - just shift its result correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convr1d(double[] a, int m, double[] b, int n, out double[] r)
+    {
+        r = new double[0];
+        conv.convr1d(a, m, b, n, ref r);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional real deconvolution (inverse of ConvC1D()).
+
+    Algorithm has M*log(M)) complexity for any M (composite or prime).
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
+        M   -   convolved signal length
+        B   -   array[0..N-1] - response
+        N   -   response length, N<=M
+
+    OUTPUT PARAMETERS
+        R   -   deconvolved signal. array[0..M-N].
+
+    NOTE:
+        deconvolution is unstable process and may result in division  by  zero
+    (if your response function is degenerate, i.e. has zero Fourier coefficient).
+
+    NOTE:
+        It is assumed that A is zero at T<0, B is zero too.  If  one  or  both
+    functions have non-zero values at negative T's, you  can  still  use  this
+    subroutine - just shift its result correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convr1dinv(double[] a, int m, double[] b, int n, out double[] r)
+    {
+        r = new double[0];
+        conv.convr1dinv(a, m, b, n, ref r);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional circular real convolution.
+
+    Analogous to ConvC1DCircular(), see ConvC1DCircular() comments for more details.
+
+    INPUT PARAMETERS
+        S   -   array[0..M-1] - real signal
+        M   -   problem size
+        B   -   array[0..N-1] - real response
+        N   -   problem size
+
+    OUTPUT PARAMETERS
+        R   -   convolution: A*B. array[0..M-1].
+
+    NOTE:
+        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
+    negative T's, you can still use this subroutine - just  shift  its  result
+    correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convr1dcircular(double[] s, int m, double[] r, int n, out double[] c)
+    {
+        c = new double[0];
+        conv.convr1dcircular(s, m, r, n, ref c);
+        return;
+    }
+
+    /*************************************************************************
+    1-dimensional complex deconvolution (inverse of ConvC1D()).
+
+    Algorithm has M*log(M)) complexity for any M (composite or prime).
+
+    INPUT PARAMETERS
+        A   -   array[0..M-1] - convolved signal, A = conv(R, B)
+        M   -   convolved signal length
+        B   -   array[0..N-1] - response
+        N   -   response length
+
+    OUTPUT PARAMETERS
+        R   -   deconvolved signal. array[0..M-N].
+
+    NOTE:
+        deconvolution is unstable process and may result in division  by  zero
+    (if your response function is degenerate, i.e. has zero Fourier coefficient).
+
+    NOTE:
+        It is assumed that B is zero at T<0. If  it  has  non-zero  values  at
+    negative T's, you can still use this subroutine - just  shift  its  result
+    correspondingly.
+
+      -- ALGLIB --
+         Copyright 21.07.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void convr1dcircularinv(double[] a, int m, double[] b, int n, out double[] r)
+    {
+        r = new double[0];
+        conv.convr1dcircularinv(a, m, b, n, ref r);
+        return;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
     1-dimensional complex cross-correlation.
 
